﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
package at.ssw.jku.model;

import javafx.beans.property.BooleanProperty;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleBooleanProperty;
import javafx.beans.property.SimpleIntegerProperty;

public final class Goody {
  private IntegerProperty xProperty = new SimpleIntegerProperty();
  private IntegerProperty yProperty = new SimpleIntegerProperty();
  private IntegerProperty valueProperty = new SimpleIntegerProperty();
  private BooleanProperty availableProperty = new SimpleBooleanProperty();
  
  public void consume() {
    availableProperty.set(false);
  }
  
  public void reset() {
    valueProperty.set(0);
    availableProperty.set(false);
  }
  
  public void plant(int x, int y, int value) {
    xProperty.set(x);
    yProperty.set(y);
    valueProperty.set(value);
    availableProperty.set(true);
  }
  
  public IntegerProperty xProperty() {
    return xProperty;
  }
  
  public int getX() {
    return xProperty.get();
  }
  
  public void setX(int x) {
    xProperty.set(x);
  }
  
  public IntegerProperty yProperty() {
    return yProperty;
  }

  public int getY() {
    return yProperty.get();
  }

  public void setY(int y) {
    yProperty.set(y);
  }
  
  public IntegerProperty valueProperty() {
    return valueProperty;
  }
  
  public int getValue() {
    return valueProperty.get();
  }
  
  public void setValue(int value) {
    valueProperty.set(value);
  }
  
  public BooleanProperty availableProperty() {
    return availableProperty;
  }
  
  public boolean isAvailable() {
    return availableProperty.get();
  }
  
  public void setAvailable(boolean available) {
    availableProperty.set(available);
  }
  
}
